########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_custr.4gs/detail.4gl  1.10  Delta: 9/4/90
########################################################################

globals "globals.4gl"

#######################################################################
function lld_input()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#   - scrolling input array
#   - must call set_count before input array
#
    define
        tab_flag        char(1),
        cur_pos         smallint,
        true_false      smallint,
        n               smallint 

    if curr_form = "1"
    then
        let curr_form = "2"
        display form screen2
        call display_name()
    end if

    call set_count(rec1_cnt)    # this must be called before input array
    input array p_rshipr without defaults from s_rshipr.*
        on key (control-i)
            let tab_flag = "Y"
            exit input
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(2)
        on key (control-f)
            # add/update user defined fields...
            if m_rcustr.cust_code is null
              then call al_addlz("strcustr",p_rcustr.cust_code,"","")
              else call al_addlz("strcustr",m_rcustr.cust_code,"","")
            end if
        before row
            let cur_pos = arr_curr()
        after delete
            let n = arr_count() + 1
            initialize p_rshipr[n].* to null
        after row
            if not lcl_chkinput(cur_pos)
            then
                call mustfill(
                    p_rshipr[cur_pos].ship_to_code,"ship to code")
                    returning true_false
            end if
        after field ship_to_code
            if lcl_chkdup(cur_pos)
            then
                call fg_err(2) # duplicate ship to code found
                next field ship_to_code
            end if
    end input
    if tab_flag = "Y"
    then
        return -1
    end if

    if header_first
    then
        let curr_form = "1"
        display form screen1
        call llh_display()
    end if

    return 0
end function
# lld_input()

#######################################################################
function lld_chkinput()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   - this function is called upon exiting the input statement.
#     the "after input" clause in the input statement can't call this
#     because a tab (control-i) needs to run this function also.
#
#   if you have any must-fill type fields on the screen, you can use
#   the function "mustfill()" that comes with infourgen.  it's syntax is:
#       mustfill(variable_name,"description of that variable")
#           returning true/false based upon no_data/data in that field.
#   it's use in this context is:
#       if mustfill(p_gchrt.acct_no,"Account Number") then return false end if
#
    return true
end function
# lld_chkinput()

#######################################################################
function lcl_chkinput(n)
#   returns true/false based upon good/bad data in row
#######################################################################
    define
        n   integer    # array cursor

        if  p_rshipr[n].ship_to_code is null and
           (p_rshipr[n].bus_name is not null or
            p_rshipr[n].taxable is not null or
            p_rshipr[n].contact is not null or
            p_rshipr[n].phone is not null or
            p_rshipr[n].address1 is not null or
            p_rshipr[n].address2 is not null or
            p_rshipr[n].city is not null or
            p_rshipr[n].state is not null or
            p_rshipr[n].zip is not null or
            p_rshipr[n].country is not null or
            p_rshipr[n].spec_shipping is not null)
    then
        return false
    end if
    return true
end function
# lcl_chkinput(n)

#######################################################################
function lcl_chkdup(n)
#   returns true/false based upon duplicate ship to number
#######################################################################
    define
        n   smallint,   # working number
        m   smallint,   # working number
        dup_result  smallint
    let dup_result = false
    if p_rshipr[n].ship_to_code is null
        then
        return dup_result
    end if
    for m = 1 to rec1_max
        if n = m
        then
            continue for
        end if
        if p_rshipr[n].ship_to_code = p_rshipr[m].ship_to_code
        then
            let dup_result = true
            exit for
        end if
    end for
    return dup_result
end function
# lcl_chkdup(n)

#######################################################################
function lld_display()
#######################################################################
#   - display the first array elements onto the screen
#
    define
        n   smallint    # working number

    if curr_form = "1" then return end if

    call display_name()

    for n = 1 to scr1_max
        display p_rshipr[n].* to s_rshipr[n].*
    end for

end function
# lld_display()

#######################################################################
function lld_p_prep(n)
#######################################################################
#   - this function creates the p_* record array (element n)
#     from the m_* record
#
    define
        n   smallint                # array element number

    let p_rshipr[n].ship_to_code = m_rshipr.ship_to_code
    let p_rshipr[n].bus_name = m_rshipr.bus_name
    let p_rshipr[n].taxable = m_rshipr.taxable
    let p_rshipr[n].contact = m_rshipr.contact
    let p_rshipr[n].phone = m_rshipr.phone
    let p_rshipr[n].address1 = m_rshipr.address1
    let p_rshipr[n].address2 = m_rshipr.address2
    let p_rshipr[n].city = m_rshipr.city
    let p_rshipr[n].state = m_rshipr.state
    let p_rshipr[n].zip = m_rshipr.zip
    let p_rshipr[n].country = m_rshipr.country
    let p_rshipr[n].spec_shipping = m_rshipr.spec_shipping

end function
# lld_p_prep()

#######################################################################
function lld_m_prep(n)
#######################################################################
#   - this function creates the m_* record from the
#     p_* record array (element n) and from the elements of the
#     header record that ties the header to the detail lines.
#
    define
        n   smallint                # array element number

    # items from the header...
    let m_rshipr.cust_code = p_rcustr.cust_code

    # items from the p_ record array...
    let m_rshipr.ship_to_code = p_rshipr[n].ship_to_code
    let m_rshipr.bus_name = p_rshipr[n].bus_name
    let m_rshipr.taxable = p_rshipr[n].taxable
    let m_rshipr.contact = p_rshipr[n].contact
    let m_rshipr.phone = p_rshipr[n].phone
    let m_rshipr.address1 = p_rshipr[n].address1
    let m_rshipr.address2 = p_rshipr[n].address2
    let m_rshipr.city = p_rshipr[n].city
    let m_rshipr.state = p_rshipr[n].state
    let m_rshipr.zip = p_rshipr[n].zip
    let m_rshipr.country = p_rshipr[n].country
    let m_rshipr.spec_shipping = p_rshipr[n].spec_shipping

end function
# lld_m_prep()

#######################################################################
function lld_read()
#######################################################################
#   - this function reads in all of the array elements from disk
#   - it uses a cursor, but doesn't lock any rows.
#   - it reads into the m_* record, and calls p_prep for all array elements
#
    define
        n           smallint    # working number
    whenever error continue
    declare d_cursor cursor for
        select * from strshipr where
            strshipr.cust_code = m_rcustr.cust_code
            order by ship_to_code
    open d_cursor
    let n = 0
    foreach d_cursor into m_rshipr.*
        let n = n + 1
        if n > rec1_max
        then
            error " Error: Too many rows in strshipr to read. "
            let rec1_cnt = 0
            call set_count(rec1_cnt)
            close d_cursor
            let sqlca.sqlcode = -1
            return
        end if
        call lld_p_prep(n)                # move data from m_* to p_[].*
    end foreach
    let rec1_cnt = n
    call set_count(rec1_cnt)
    close d_cursor
    return
end function
# lld_read()

#######################################################################
function lld_delete()
#######################################################################
#   - this function is for deleting all rows in the array
#
    delete from strshipr where
            strshipr.cust_code = m_rcustr.cust_code
end function
# lld_delete()

#######################################################################
function lld_add()
#######################################################################
#   - this function is for writing all rows in the array
#
    define
        n   smallint    # working number
    whenever error continue
    for n = 1 to rec1_cnt       # for all active array elements
        if p_rshipr[n].ship_to_code is not null
            and p_rshipr[n].ship_to_code > " "
        then
            call lld_m_prep(n)
            insert into strshipr values(m_rshipr.*)
        end if
    end for
    whenever error call error_handler
    return
end function
# lld_add()

#######################################################################
function display_name()
#######################################################################
#   - display the customer name on the detail screen
#
    define
        cust_name    char(90)

    let cust_name = p_rcustr.cust_code clipped, " -  ",
                    p_rcustr.bus_name clipped,
        " ---------------------------------------------"
    let cust_name = cust_name[1,45]
    display cust_name clipped at 4,32 attribute(blue)

end function
# display_name()

