########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_custr.4gs/header.4gl  1.9  Delta: 8/31/90
########################################################################

globals "globals.4gl"

#######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#
    define
        in_zoom                 smallint,
        scratch                 char(10),
        old_cust_code           like strcustr.cust_code,
        old_on_acct             like strcustr.on_acct_amt,
        old_acct_no             like strcustr.ar_acct_dflt,
        old_department          like strcustr.ar_department_dflt,
        old_terms_code          like strcustr.terms_code,
        old_act_grp             like strcustr.act_grp,
        generic_desc            char(10)

    if curr_form = "2"
    then
        if dtl_update
        then
            let dtl_update = false
            return -1
        else
            let curr_form = "1"
            display form screen1
        end if
    end if

    # Default acct_bal and on_acct_amt to zero if null
    if p_rcustr.acct_bal is null then let p_rcustr.acct_bal = 0 end if
    if p_rcustr.on_acct_amt is null
      then let p_rcustr.on_acct_amt = 0 end if

    let in_zoom = false
    input p_rcustr.* without defaults from s_rcustr.*
        on key (control-i)
            return -1
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(1)
        on key (control-f)
            # add/update user defined fields...
            if m_rcustr.cust_code is null
              then call al_addlz("strcustr",p_rcustr.cust_code,"","")
              else call al_addlz("strcustr",m_rcustr.cust_code,"","")
            end if
        on key (control-z)
        case
              when infield(ar_acct_dflt)
                let old_acct_no = p_rcustr.ar_acct_dflt
                call al_chrtz() returning p_rcustr.ar_acct_dflt
                if p_rcustr.ar_acct_dflt is null
                then
                    let p_rcustr.ar_acct_dflt = old_acct_no
                end if
                display by name p_rcustr.ar_acct_dflt
                next field ar_acct_dflt
              when infield(ar_department_dflt)
                let old_department = p_rcustr.ar_department_dflt
                call al_deptz() returning p_rcustr.ar_department_dflt
                if p_rcustr.ar_department_dflt is null
                then
                    let p_rcustr.ar_department_dflt = old_department
                end if
                display by name p_rcustr.ar_department_dflt
                next field ar_department_dflt
              when infield(terms_code)
                let in_zoom = true
                let old_terms_code = p_rcustr.terms_code
                call ar_termz() returning p_rcustr.terms_code
                if p_rcustr.terms_code is null
                then
                    let p_rcustr.terms_code = old_terms_code
                end if
                display by name p_rcustr.terms_code
                next field terms_code
              when infield(act_grp)
                let in_zoom = true
                let old_act_grp = p_rcustr.act_grp
                call al_grp_z() returning p_rcustr.act_grp
                if p_rcustr.act_grp is null
                then
                    let p_rcustr.act_grp = old_act_grp
                end if
                display by name p_rcustr.act_grp
                next field act_grp
        end case
        before field cust_code
            let old_cust_code = p_rcustr.cust_code
        after field cust_code
            if not new_cust and old_cust_code != p_rcustr.cust_code
            then
                call fg_err(5) # cannot change existing customer codes
                let p_rcustr.cust_code = old_cust_code
                display by name p_rcustr.cust_code
            end if
            if new_cust
            then
                if p_rcustr.cust_code is not null
                then
                    if ar_custd(p_rcustr.cust_code)
                    then
                        call fg_err(1) # duplicate customer code
                        let p_rcustr.cust_code = old_cust_code
                        display by name p_rcustr.cust_code
                        next field cust_code
                    end if
                end if
            end if
        before field on_acct_amt
            let old_on_acct = p_rcustr.on_acct_amt
        after field on_acct_amt
            let p_rcustr.on_acct_amt = al_round("a",
                p_rcustr.on_acct_amt)
            let p_rcustr.acct_bal = p_rcustr.acct_bal -
                old_on_acct + p_rcustr.on_acct_amt
            display by name p_rcustr.acct_bal
        before field terms_code
            if in_zoom
            then
                let in_zoom = false
            else
                let old_terms_code = p_rcustr.terms_code
            end if
        after field terms_code
            if p_rcustr.terms_code is not null
            then
                if p_rcustr.terms_code = old_terms_code
                then else
                    call ar_termn(p_rcustr.terms_code) returning
                        p_rcustr.terms_desc, scratch, scratch, scratch
                    display by name p_rcustr.terms_desc
                    if p_rcustr.terms_desc = "NOT FOUND"
                    then
                        call fg_err(10) # Warning:  Terms code not found
                        next field terms_code
                    end if
                end if
            else
                let p_rcustr.terms_desc = null
                display by name p_rcustr.terms_desc
            end if
        before field act_grp
            if in_zoom
            then
                let in_zoom = false
            else
                let old_act_grp = p_rcustr.act_grp
            end if
        after field act_grp
            if p_rcustr.act_grp is not null
            then
                if p_rcustr.act_grp = old_act_grp
                then else
                    call al_grp_n(p_rcustr.act_grp) returning
                        p_rcustr.grp_desc
                    display by name p_rcustr.grp_desc
                    if p_rcustr.grp_desc = "NOT FOUND"
                    then
                        call fg_err(11) # Warning:  Account group not found
                        next field act_grp
                    end if
                end if
            else
                let p_rcustr.terms_desc = null
                display by name p_rcustr.terms_desc
            end if
        after field ar_acct_dflt
            if p_rcustr.ar_acct_dflt is not null
            then
                call al_chrtn(p_rcustr.ar_acct_dflt) returning
                    generic_desc, scratch
                if generic_desc = "NOT FOUND"
                then
                    call fg_err(6) # ledger account not found
                    next field ar_acct_dflt
                end if
            end if
        after field ar_department_dflt
            if p_rcustr.ar_department_dflt is not null
            then
                call al_deptn(p_rcustr.ar_department_dflt) returning
                    generic_desc
                if generic_desc = "NOT FOUND"
                then
                    call fg_err(7) # department not found
                    next field ar_department_dflt
                end if
            end if
    after field taxable
        if p_rcustr.taxable is not null
        then
            if p_rcustr.taxable != "N" and p_rcustr.taxable != "Y"
            then 
                call fg_err(8) # field must be a "N" or "Y"
                next field taxable
            end if
        end if
    after field ar_type
        if p_rcustr.ar_type is not null
        then
            if p_rcustr.ar_type != "O" and p_rcustr.ar_type != "B"
            then 
                call fg_err(9) # field must be a "B" or "O"
                next field ar_type
            end if
        end if
    after field fin_chg
        if p_rcustr.fin_chg is not null
        then
            if p_rcustr.fin_chg != "N" and p_rcustr.fin_chg != "Y"
            then 
                call fg_err(8) # field must be a "N" or "Y"
                next field fin_chg
            end if
        end if
    end input
    return 0
end function
# llh_input()

#######################################################################
function llh_chkinput()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   this function is called upon exiting the input statement.
#   the "after input" clause in the input statement can't call
#   this because a tab (control-i) needs to run this function also.
#
#   if you have any must-fill type fields on the screen, you can use
#   the function "mustfill()" that comes with infourgen.  it's syntax is:
#       mustfill(variable_name,"description of that variable")
#           returning true/false based upon no_data/data in that field.
#   it's use in this context is:
#       if mustfill(p_gchrt.acct_no,"Account Number") then return false end if
#
    if mustfill(p_rcustr.cust_code,"Customer Code")
    then
        return false
    end if
    if mustfill(p_rcustr.bus_name,"Business Name")
    then
        return false
    end if
    if p_rcustr.taxable is null
    then
        let p_rcustr.taxable = "Y"
    end if
    if p_rcustr.ar_type is null
    then
        let p_rcustr.ar_type = "O"
    end if
    if p_rcustr.fin_chg is null
    then
        let p_rcustr.fin_chg = "Y"
    end if
    call llh_display()
    return true
end function
# llh_chkinput()

#######################################################################
function llh_display()
#######################################################################
#   - display all p_* variables onto the screen
#
    if curr_form != "1" then return end if
    display p_rcustr.* to s_rcustr.*
end function
# llh_display()

#######################################################################
function llh_p_prep()
#######################################################################
#   - this function creates the p_* record from the m_* record
#
    define
        scratch                 char(10)
    let p_rcustr.cust_code = m_rcustr.cust_code
    let p_rcustr.bus_name = m_rcustr.bus_name
    let p_rcustr.taxable = m_rcustr.taxable
    let p_rcustr.contact = m_rcustr.contact
    let p_rcustr.phone = m_rcustr.phone
    let p_rcustr.address1 = m_rcustr.address1
    let p_rcustr.address2 = m_rcustr.address2
    let p_rcustr.city = m_rcustr.city
    let p_rcustr.state = m_rcustr.state
    let p_rcustr.zip = m_rcustr.zip
    let p_rcustr.country = m_rcustr.country
    let p_rcustr.spec_shipping = m_rcustr.spec_shipping
    let p_rcustr.ar_type = m_rcustr.ar_type
    let p_rcustr.stmt_cycle = m_rcustr.stmt_cycle
    let p_rcustr.fin_chg = m_rcustr.fin_chg
    let p_rcustr.credit_limit = m_rcustr.credit_limit
    let p_rcustr.ar_acct_dflt = m_rcustr.ar_acct_dflt
    let p_rcustr.ar_department_dflt = m_rcustr.ar_department_dflt
    let p_rcustr.terms_code = m_rcustr.terms_code
    if p_rcustr.terms_code is not null
    then
        call ar_termn(p_rcustr.terms_code) returning p_rcustr.terms_desc,
            scratch, scratch, scratch
    end if
    let p_rcustr.act_grp = m_rcustr.act_grp
    if p_rcustr.act_grp is not null
    then
        call al_grp_n(p_rcustr.act_grp) returning p_rcustr.grp_desc
    end if
    let p_rcustr.spec_billing = m_rcustr.spec_billing
    let p_rcustr.stmt_date = m_rcustr.stmt_date
    let p_rcustr.stmt_amount = m_rcustr.stmt_amount
    let p_rcustr.last_pay_date = m_rcustr.last_pay_date
    let p_rcustr.on_acct_amt = m_rcustr.on_acct_amt
    let p_rcustr.acct_bal = m_rcustr.acct_bal
end function
# llh_p_prep()

#######################################################################
function llh_m_prep()
#######################################################################
#   - this function creates the m_* record from the p_* record
#
    # change key to user defined fields
    # if key was changed during input
    if   m_rcustr.cust_code is not null
     and m_rcustr.cust_code != p_rcustr.cust_code
    then
        call al_addlnk("strcustr",m_rcustr.cust_code,p_rcustr.cust_code)
    end if
    let m_rcustr.cust_code = p_rcustr.cust_code
    let m_rcustr.bus_name = p_rcustr.bus_name
    let m_rcustr.taxable = p_rcustr.taxable
    let m_rcustr.contact = p_rcustr.contact
    let m_rcustr.phone = p_rcustr.phone
    let m_rcustr.address1 = p_rcustr.address1
    let m_rcustr.address2 = p_rcustr.address2
    let m_rcustr.city = p_rcustr.city
    let m_rcustr.state = p_rcustr.state
    let m_rcustr.zip = p_rcustr.zip
    let m_rcustr.country = p_rcustr.country
    let m_rcustr.spec_shipping = p_rcustr.spec_shipping
    let m_rcustr.ar_type = p_rcustr.ar_type
    let m_rcustr.stmt_cycle = p_rcustr.stmt_cycle
    if p_rcustr.fin_chg is null or
         p_rcustr.fin_chg != "Y"
    then
        let p_rcustr.fin_chg = "N"
    end if
    let m_rcustr.fin_chg = p_rcustr.fin_chg
    let m_rcustr.credit_limit = p_rcustr.credit_limit
    let m_rcustr.ar_acct_dflt = p_rcustr.ar_acct_dflt
    let m_rcustr.ar_department_dflt = p_rcustr.ar_department_dflt
    let m_rcustr.terms_code = p_rcustr.terms_code
    let m_rcustr.act_grp = p_rcustr.act_grp
    let m_rcustr.spec_billing = p_rcustr.spec_billing
    if p_rcustr.stmt_date is null
    then
        let p_rcustr.stmt_date = "01/01/80"
    end if
    let m_rcustr.stmt_date = p_rcustr.stmt_date
    if p_rcustr.stmt_amount is null
    then
        let p_rcustr.stmt_amount = 0
    end if
    let m_rcustr.stmt_amount = p_rcustr.stmt_amount
    if p_rcustr.last_pay_date is null
    then
        let p_rcustr.last_pay_date = "01/01/80"
    end if
    let m_rcustr.last_pay_date = p_rcustr.last_pay_date
    if p_rcustr.on_acct_amt is null
    then
        let p_rcustr.on_acct_amt = 0
    end if
    let m_rcustr.on_acct_amt = p_rcustr.on_acct_amt
    if p_rcustr.acct_bal is null
    then
        let p_rcustr.acct_bal = 0
    end if
    let m_rcustr.acct_bal = p_rcustr.acct_bal
    if m_rcustr.arch_bal is null
    then
        let m_rcustr.arch_bal = 0
    end if
end function
# llh_m_prep()

#######################################################################
function llh_read(ring_rowid)
#######################################################################
#   - this function reads in all of the p_* variables from disk.
#   - it does not use a cursor, so it doesn't lock the row.
#
    define
        ring_rowid  integer     # rowid of record to read
    whenever error continue
    select * into m_rcustr.* from strcustr where rowid = ring_rowid
    whenever error call error_handler
    if sqlca.sqlcode != 0
    then
        return
    end if
    call llh_p_prep()
    return
end function
# llh_read()

#######################################################################
function llh_delete(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    delete from strcustr
        where rowid = ring_rowid
    if sqlca.sqlcode = 0
    then
        # delete user defined fields
        call al_addld("strcustr",p_rcustr.cust_code)
    end if
end function
# llh_delete()

#######################################################################
function llh_add()
#######################################################################
#   - insert a new reference record, and all n-lines associated with it.
#
    whenever error continue
    insert into strcustr values(m_rcustr.*)
    whenever error call error_handler
end function
# llh_add()

#######################################################################
function llh_update(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update strcustr set strcustr.* = m_rcustr.*
        where rowid = ring_rowid
end function
# llh_update()
