########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../data/ar/b_syst.4gl  1.3  Delta: 9/20/90
########################################################################

globals "globals.4gl"

#####################################################################
function b1_define()
#####################################################################
#  This function defines the browse cursor logic.
#
    let num.b_syst = 1
    let brw[1].id = "syst"
    let brw[1].tabname = "systables"

    let num.t_syst.syst = 1
    let brw[1].tab[1].id = "syst"
    let brw[1].tab[1].tabname = "systables"
    let brw[1].tab[1].ok_delete = false
    let brw[1].tab[1].sel_filter = "1=1"
    let brw[1].tab[1].sel_order = "tabname"
    let brw[1].tab[1].arr_max = 1

    let num.t_syst.cols = 2
    let brw[1].tab[2].id = "cols"
    let brw[1].tab[2].tabname = "syscolumns"
    let brw[1].tab[2].ok_delete = false
    let brw[1].tab[2].sel_filter = "1=1"
    let brw[1].tab[2].sel_order = "colno"
    let brw[1].tab[2].arr_max = 1000

    let num.t_syst.indx = 3
    let brw[1].tab[3].id = "indx"
    let brw[1].tab[3].tabname = "sysindexes"
    let brw[1].tab[3].ok_delete = false
    let brw[1].tab[3].sel_filter = "1=1"
    let brw[1].tab[3].sel_order = "idxname"
    let brw[1].tab[3].arr_max = 10

    let num.t_syst.vyou = 4
    let brw[1].tab[4].id = "view"
    let brw[1].tab[4].tabname = "sysviews"
    let brw[1].tab[4].ok_delete = false
    let brw[1].tab[4].sel_filter = "1=1"
    let brw[1].tab[4].sel_order = "seqno"
    let brw[1].tab[4].arr_max = 20

    return
end function
# b1_define()

#####################################################################
function b1_init()
#####################################################################
#  This function initializes the browse cursor using the
#  criteria found in the brw[].tab[1].sel_filter,
#  brw[].tab[1].sel_order, and the g_sel_construct variables.
#  It also loads the initial b_* elements.

    define
        curs_cnt  integer     # number of elements in the cursor

    # initialize some variables
    call b1_clear()
    let brw[1].curs_ptr = 0
    let brw[1].row_id = 0

    # no use finding anything if sel_filter = "1=0"
    if  brw[1].tab[1].sel_filter = "1=0"
     or g_sel_construct  = "1=0"
    then
        let brw[1].curs_cnt  = 0
        let g_sel_construct = "1=1"
        return
    end if

    # define the cursor
    if brw[1].tab[1].sel_filter is null
        then let brw[1].tab[1].sel_filter = "1=1"
    end if
    if brw[1].tab[1].sel_order is null
    then
        let g_sql_str =
            "select rowid from systables where ",
                brw[1].tab[1].sel_filter clipped,
                " and ", g_sel_construct clipped
    else
        let g_sql_str =
            "select rowid, ", brw[1].tab[1].sel_order clipped,
            " from systables where ",brw[1].tab[1].sel_filter clipped,
            " and ", g_sel_construct clipped,
            " order by ", brw[1].tab[1].sel_order clipped
    end if

    # reset the construct portion
    let g_sel_construct = "1=1"
    prepare b1_prep from g_sql_str
    declare b1_curs scroll cursor for b1_prep

    # count the elements
    let curs_cnt = 0
    whenever error continue
    open b1_curs
    while true
        fetch next b1_curs into g_sql_str
        if sqlca.sqlcode = 0
            then let curs_cnt = curs_cnt + 1
            else exit while
        end if
    end while
    let brw[1].curs_cnt = curs_cnt
    whenever error call error_handler

    if curs_cnt = 0 then return end if

    # load data from element #1
    let brw[1].curs_ptr = 1
    call b1_fetch()
    return
end function
# b1_init()

#####################################################################
function b1_fetch()
#####################################################################
#  This function fetches the rowid from the cursor, then grabs all
#  data into the b_* elements.
#
    define
        old_cnt smallint,   # prev. array counter
        n       smallint    # array counter

    # fetch the rowid from the cursor
    if brw[1].curs_ptr > 0
    then
        whenever error continue
        fetch absolute brw[1].curs_ptr b1_curs into brw[1].row_id
        whenever error call error_handler
        if sqlca.sqlcode != 0
        then
            let brw[1].row_id = 0
            return
        end if
    end if

    # table 1: systables
    whenever error continue
    select
        rowid, 0,
        tabname, owner, tabid, rowsize, ncols, nindexes, nrows,
        created, version, tabtype
        into b_syst.t_syst.*
        from systables where
        rowid = brw[1].row_id
    whenever error call error_handler
    if sqlca.sqlcode != 0
    then
        let brw[1].row_id = 0
        call b1_clear()
        return
    end if

    # table 2: syscolumns  (array)
    whenever error continue
    let old_cnt = brw[1].tab[2].arr_cnt
    if brw[1].tab[2].sel_filter is null
        then let brw[1].tab[2].sel_filter = "1=1"
    end if
    let g_sql_str = "select rowid, 0, ",
        "colname, tabid, colno, coltype, collength ",
        "from syscolumns where ",
        "tabid = ",
        b_syst.t_syst.tabid clipped,
        " and ", brw[1].tab[2].sel_filter clipped
    if brw[1].tab[2].sel_order is not null
    then
        let g_sql_str = g_sql_str clipped, " order by ",
            brw[1].tab[2].sel_order clipped
    end if
    prepare b1_cols from g_sql_str
    declare c1_cols scroll cursor for b1_cols
    open c1_cols
    let n = 0
    if sqlca.sqlcode = 0
    then
        foreach c1_cols into b_syst.t_cols[n + 1].*
            let n = n + 1
            if n = brw[1].tab[2].arr_max
            then
                exit foreach
            end if
        end foreach
    end if
    close c1_cols
    whenever error call error_handler
    # set new arr_cnt
    let brw[1].tab[2].arr_cnt = n
    let brw[1].tab[2].num_del = 0
    # clear out any data larger than arr_cnt
    if old_cnt > n
    then
        initialize b_syst.z_cols.* to null
        for n = old_cnt to (brw[1].tab[2].arr_cnt + 1) step - 1
            let b_syst.t_cols[n].* = b_syst.z_cols.*
        end for
    end if

    # table 3: sysindexes  (array)
    whenever error continue
    let old_cnt = brw[1].tab[3].arr_cnt
    if brw[1].tab[3].sel_filter is null
        then let brw[1].tab[3].sel_filter = "1=1"
    end if
    let g_sql_str = "select rowid, 0, ",
        "idxname, owner, tabid, idxtype, clustered, part1, part2, ",
        "part3, part4, part5, part6, part7, part8 ",
        "from sysindexes where ",
        "tabid = ",
        b_syst.t_syst.tabid clipped,
        " and ", brw[1].tab[3].sel_filter clipped
    if brw[1].tab[3].sel_order is not null
    then
        let g_sql_str = g_sql_str clipped, " order by ",
            brw[1].tab[3].sel_order clipped
    end if
    prepare b1_indx from g_sql_str
    declare c1_indx scroll cursor for b1_indx
    open c1_indx
    let n = 0
    if sqlca.sqlcode = 0
    then
        foreach c1_indx into b_syst.t_indx[n + 1].*
            let n = n + 1
            if n = brw[1].tab[3].arr_max
            then
                exit foreach
            end if
        end foreach
    end if
    close c1_indx
    whenever error call error_handler
    # set new arr_cnt
    let brw[1].tab[3].arr_cnt = n
    let brw[1].tab[3].num_del = 0
    # clear out any data larger than arr_cnt
    if old_cnt > n
    then
        initialize b_syst.z_indx.* to null
        for n = old_cnt to (brw[1].tab[3].arr_cnt + 1) step - 1
            let b_syst.t_indx[n].* = b_syst.z_indx.*
        end for
    end if

    # table 4: sysviews  (array)
    whenever error continue
    let old_cnt = brw[1].tab[4].arr_cnt
    if brw[1].tab[4].sel_filter is null
        then let brw[1].tab[4].sel_filter = "1=1"
    end if
    let g_sql_str = "select rowid, 0, ",
        "tabid, seqno, text ",
        "from sysviews where ",
        "tabid = ",
        b_syst.t_syst.tabid clipped,
        " and ", brw[1].tab[4].sel_filter clipped
    if brw[1].tab[4].sel_order is not null
    then
        let g_sql_str = g_sql_str clipped, " order by ",
            brw[1].tab[4].sel_order clipped
    end if
    prepare b1_view from g_sql_str
    declare c1_view scroll cursor for b1_view
    open c1_view
    let n = 0
    if sqlca.sqlcode = 0
    then
        foreach c1_view into b_syst.t_view[n + 1].*
            let n = n + 1
            if n = brw[1].tab[4].arr_max
            then
                exit foreach
            end if
        end foreach
    end if
    close c1_view
    whenever error call error_handler
    # set new arr_cnt
    let brw[1].tab[4].arr_cnt = n
    let brw[1].tab[4].num_del = 0
    # clear out any data larger than arr_cnt
    if old_cnt > n
    then
        initialize b_syst.z_view.* to null
        for n = old_cnt to (brw[1].tab[4].arr_cnt + 1) step - 1
            let b_syst.t_view[n].* = b_syst.z_view.*
        end for
    end if

    # call the browse trigger
    if tb_syst("after read") then end if

    return
end function
# b1_fetch()

#####################################################################
function b1_close()
#####################################################################
#
    whenever error continue
    close b1_curs
    whenever error call error_handler
end function
# b1_close()

#####################################################################
function b1_lock()
#####################################################################
#  This function opens a cursor for update selecting just the
#  record defined by the cursors rowid.
#  Because it fetches the record with an update cursor, the record
#  is locked.
#  It's only meaning in life is to lock the record. not read it.
#
    define
        row_id  integer,    # rowid of record to read
        getid   integer     # something to fetch into
    whenever error continue
    declare c1_lock cursor for
        select rowid into getid from systables
        where rowid = brw[1].row_id
        for update
    open c1_lock
    fetch c1_lock
    whenever error call error_handler
    return
end function
# b1_lock()

#####################################################################
function b1_unlock()
#####################################################################
#  This function unlocks the rowid pointed to by the cursor
#
    whenever error continue
    close c1_lock
    whenever error call error_handler
end function
# b1_lock()

#####################################################################
function b1_clear()
#####################################################################
#  This function clears out all of the b_* record elements
#
    define
        n smallint          # counter

    # systables table:
    initialize b_syst.t_syst.* to null

    # syscolumns table variables:
    initialize b_syst.z_cols.* to null
    for n = 1 to brw[1].tab[2].arr_max
        let b_syst.t_cols[n].* = b_syst.z_cols.*
    end for
    let brw[1].tab[2].arr_cnt = 0
    let brw[1].tab[2].num_del = 0

    # sysindexes table variables:
    initialize b_syst.z_indx.* to null
    for n = 1 to brw[1].tab[3].arr_max
        let b_syst.t_indx[n].* = b_syst.z_indx.*
    end for
    let brw[1].tab[3].arr_cnt = 0
    let brw[1].tab[3].num_del = 0

    # sysviews table variables:
    initialize b_syst.z_view.* to null
    for n = 1 to brw[1].tab[4].arr_max
        let b_syst.t_view[n].* = b_syst.z_view.*
    end for
    let brw[1].tab[4].arr_cnt = 0
    let brw[1].tab[4].num_del = 0

end function
# b1_clear()

#####################################################################
function tb_syst(trig_txt)
#####################################################################
#  This is the trigger function for the browser.
#
    define
        trig_txt char(20)

    return true
end function
# tb_syst()
