#####################################################################
# Copyright (C) 1988,1989
# Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../data/ar/globals.4gl  1.4  Delta: 6/1/90
#####################################################################
# The contents of this file between the # start/end custom comments
# may be changed.  The code generator will preserve any changes
# between these comments.  Changes outside of the # start/end custom
# comments will be overwritten by the code generator.
#

globals
    define

# start custom

# end custom

        num record            # browse, screen, and window numbers
            b_syst smallint,  # syst browse number
            t_syst record     # syst browse sub-table numbers
                syst smallint,  # syst sub-table number
                cols smallint,  # cols sub-table number
                indx smallint,  # indx sub-table number
                vyou smallint   # view sub-table number
            end record
        end record,

        g_progid char(18),      # program identificaton
        g_err_txt char(70),     # program generated error text
        g_sql_str char(2048),   # sql exec string
        g_outlevel smallint,    # display output level (0-4)
        g_curr_brw smallint,    # current browser number
        g_curr_tab smallint,    # current browse table number
        g_sel_construct char(512),# sql construct string
        g_database char(20),    # database name
        g_unload_dir char(256), # pathname for load/unload data
        g_quote char(1),        # storage for the quote character
        g_bkslsh char(1),       # storage for the backslash character
        g_err_action char(10),  # error actions: continue, quit, or ask

        data array[100] of char(100),  # generic data array
        del_filter char(255),  # delete filter
        unl_filter char(255),  # unload filter
          # A deletion is done on the table before the row loads
          # are done.  The default delete filter is 1=0 (for no
          # deletes), the default unload filter is 1=1 (for
          # unload all rows).  The value is set at runtime based
          # on the -l or -u flags passed on the command line.
        order_by char(255),    # order by clause

        is_schema smallint,     # no command line flag selected
        is_load smallint,       # -l command line flag selected
        is_unload smallint,     # -u command line flag selected
        is_index smallint,      # -i command line flag selected

        gc_tab smallint,        # current working tab[] array element
        gn_tab smallint,        # number of active tab[] array elements
        gx_tab smallint,        # tab[] array maximum
        gc_col smallint,        # current working col[] array element
        gn_col smallint,        # number of active col[] array elements
        gx_col smallint,        # col[] array maximum
        gc_idx smallint,        # current working idx[] array element
        gn_idx smallint,        # number of active idx[] array elements
        gx_idx smallint,        # idx[] array maximum
        gc_viw smallint,        # current working viw[] array element
        gn_viw smallint,        # no. of active viw[] array elements
        gx_viw smallint,        # viw[] array maximum
        gc_ren smallint,        # current working ren[] array element
        gx_ren smallint,        # ren[] array maximum
        gc_drp smallint,        # current working drp[] array element
        gx_drp smallint,        # drp[] array maximum

        tab array[22] of record        # table information records
            tabname char(18),          # table name
            col_start smallint,        # starting column in col[] array
            col_end smallint,          # ending column in col[] array
            idx_start smallint,        # starting index in idx[] array
            idx_end smallint,          # ending index in idx[] array
            viw_start smallint,        # starting view in viw[] array
            viw_end smallint,          # ending view in viw[] array
            serial_start integer       # serial col start no. (if one)
        end record,
        col array[231] of record       # column information records
            colname char(18),          # column name
            coltype smallint,          # column type (coded)
            collength smallint         # column length (coded)
        end record,
        idx array[24] of record        # index information records
            idxname char(18),          # index name
            unique_idx char(1),        # (Y/N) is this index unique?
            clustered char(1),         # (Y/N) is this index clustered?
            part array[8] of smallint  # 8 columns (parts) to the index
        end record,
        viw array[19] of record        # view information records
            v_text char(45)            # 45 chars of view definition
        end record,
        ren array[40] of record        # rename column array (40 max)
            old_colname char(18),      # rename from
            new_colname char(18)       # rename to
        end record,
        drp array[40] of record        # drop column array (40 max)
            colname char(18)           # column to drop
        end record,

        b_syst record                     # systables browse record
            t_syst record                 # systables table record
                row_id integer,           # rowid of the element
                d_changed smallint,       # has the data changed ?
                tabname char(18),
                owner char(8),
                tabid integer,
                rowsize smallint,
                ncols smallint,
                nindexes smallint,
                nrows integer,
                created date,
                version integer,
                tabtype char(1)
            end record,
            t_cols array[1000] of record  # syscolumns table record
                row_id integer,           # rowid of the element
                d_changed smallint,       # has the data changed ?
                colname char(18),
                tabid integer,
                colno smallint,
                coltype smallint,
                collength smallint
            end record,
            z_cols record  # 1 extra working record like syscolumns
                row_id integer,
                d_changed smallint,
                colname char(18),
                tabid integer,
                colno smallint,
                coltype smallint,
                collength smallint
            end record,
            t_indx array[10] of record    # sysindexes table record
                row_id integer,           # rowid of the element
                d_changed smallint,       # has the data changed ?
                idxname char(18),
                owner char(8),
                tabid integer,
                idxtype char(1),
                clustered char(1),
                part1 smallint,
                part2 smallint,
                part3 smallint,
                part4 smallint,
                part5 smallint,
                part6 smallint,
                part7 smallint,
                part8 smallint
            end record,
            z_indx record  # 1 extra working record like sysindexes
                row_id integer,
                d_changed smallint,
                idxname char(18),
                owner char(8),
                tabid integer,
                idxtype char(1),
                clustered char(1),
                part1 smallint,
                part2 smallint,
                part3 smallint,
                part4 smallint,
                part5 smallint,
                part6 smallint,
                part7 smallint,
                part8 smallint
            end record,
            t_view array[60] of record    # sysviews table record
                row_id integer,           # rowid of the element
                d_changed smallint,       # has the data changed ?
                tabid integer,
                seqno smallint,
                v_text char(64)
            end record,
            z_view record  # 1 extra working record smallint
                row_id integer,
                d_changed smallint,
                tabid integer,
                seqno smallint,
                v_text char(64)
            end record
        end record,

        brw array[1] of record   # browse cursor definition records
            id char(4),          # browse identification
            tabname char(20),    # name of browse cursor table
            row_id  integer,     # rowid of current cursor element
            curs_cnt integer,    # number of elements in the cursor
            curs_ptr integer,    # pointer to the current cursor element
            tab array[4] of record   # other tables to read in
                id char(4),          # table identification
                tabname char(20),    # tablename
                ok_delete smallint,  # delete from this table upon delete ?
                sel_filter char(200),# filter additions to the where clause
                sel_order char(100), # the order by clause
                arr_max smallint,    # total no. of array elements (if array)
                arr_cnt smallint,    # no. of active array elements (if array)
                num_del smallint     # no. of deleted rows (del_rowid's)
            end record
        end record
end globals

