#####################################################################
# Copyright (C) 1988,1989
# Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../data/ar/schema.4gl  1.8  Delta: 6/1/90
#####################################################################

# This file represents the internal definition of
# the tables, columns, indexes, and views.
# It has been automatically generated using FourGen CASE tools.

globals "globals.4gl"

#####################################################################
function define_data()
#####################################################################
#
    define
        a char(18),   # holding bin for the column name
        b smallint,   # holding bin for the column type
        c smallint,   # holding bin for the column length
        d char(1),    # (Y/N) unique index?
        e char(1),    # (Y/N) clustered index?
        f smallint,   # part 1 of index
        g smallint,   # part 2 of index
        h smallint,   # part 3 of index
        i smallint,   # part 4 of index
        j smallint,   # part 5 of index
        k smallint,   # part 6 of index
        l smallint,   # part 7 of index
        m smallint,   # part 8 of index
        n smallint,   # generic counter
        t char(45)    # text portion of the view

    # Set the array boundaries
    let gn_tab = 22    # number of active elements in the tab[] array
    let gx_tab = 22    # maximum number of elements in the tab[] array
    let gn_col = 231   # number of active elements in the col[] array
    let gx_col = 231   # maximum number of elements in the col[] array
    let gn_idx = 24    # number of active elements in the idx[] array
    let gx_idx = 24    # maximum number of elements in the idx[] array
    let gn_viw = 19    # number of active elements in the viw[] array
    let gx_viw = 19    # maximum number of elements in the viw[] array

    # Set some default table elements
    for n = 1 to gn_tab
        let tab[n].col_start = 0
        let tab[n].col_end = 0
        let tab[n].idx_start = 0
        let tab[n].idx_end = 0
        let tab[n].viw_start = 0
        let tab[n].viw_end = 0
    end for

    # Table: pcdtablr
    let tab[1].tabname = "pcdtablr"
    let tab[1].col_start = 1
    let tab[1].col_end = 3
    let tab[1].idx_start = 1
    let tab[1].idx_end = 1
    let tab[1].serial_start = 1000
    for n = 1 to 3
        case n
          when 1  let a="prodid"  let b=256  let c=8
          when 2  let a="line_no"  let b=1  let c=2
          when 3  let a="tabname"  let b=256  let c=18
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: strcntrc
    let tab[2].tabname = "strcntrc"
    let tab[2].col_start = 4
    let tab[2].col_end = 29
    let tab[2].serial_start = 1000
    for n = 4 to 29
        case n
          when 4  let a="terms_code"  let b=0  let c=6
          when 5  let a="tax_pct"  let b=5  let c=1791
          when 6  let a="ar_acct_no"  let b=2  let c=4
          when 7  let a="ar_sales_acct_no"  let b=2  let c=4
          when 8  let a="ar_tax_acct_no"  let b=2  let c=4
          when 9  let a="ar_frght_acct_no"  let b=2  let c=4
          when 10  let a="ar_misc_acct_no"  let b=2  let c=4
          when 11  let a="ar_fc_acct_no"  let b=2  let c=4
          when 12  let a="cr_cash_acct_no"  let b=2  let c=4
          when 13  let a="cr_disc_acct_no"  let b=2  let c=4
          when 14  let a="ar_doc_no"  let b=2  let c=4
          when 15  let a="ar_post_no"  let b=2  let c=4
          when 16  let a="ar_balanced"  let b=0  let c=1
          when 17  let a="cr_doc_no"  let b=2  let c=4
          when 18  let a="cr_post_no"  let b=2  let c=4
          when 19  let a="disc_misc"  let b=0  let c=1
          when 20  let a="disc_frght"  let b=0  let c=1
          when 21  let a="disc_tax"  let b=0  let c=1
          when 22  let a="age_datetype"  let b=0  let c=1
          when 23  let a="age_per1"  let b=1  let c=2
          when 24  let a="age_per2"  let b=1  let c=2
          when 25  let a="age_per3"  let b=1  let c=2
          when 26  let a="age_dsc1"  let b=0  let c=15
          when 27  let a="age_dsc2"  let b=0  let c=15
          when 28  let a="age_dsc3"  let b=0  let c=15
          when 29  let a="age_dsc4"  let b=0  let c=15
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: strtranr
    let tab[3].tabname = "strtranr"
    let tab[3].col_start = 30
    let tab[3].col_end = 33
    let tab[3].idx_start = 2
    let tab[3].idx_end = 2
    let tab[3].serial_start = 1000
    for n = 30 to 33
        case n
          when 30  let a="orig_journal"  let b=256  let c=2
          when 31  let a="doc_no"  let b=258  let c=4
          when 32  let a="inv_chk_no"  let b=0  let c=10
          when 33  let a="doc_type"  let b=0  let c=2
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stractvd
    let tab[4].tabname = "stractvd"
    let tab[4].col_start = 34
    let tab[4].col_end = 38
    let tab[4].idx_start = 3
    let tab[4].idx_end = 4
    let tab[4].serial_start = 1000
    for n = 34 to 38
        case n
          when 34  let a="orig_journal"  let b=256  let c=2
          when 35  let a="doc_no"  let b=258  let c=4
          when 36  let a="act_type"  let b=0  let c=1
          when 37  let a="inv_doc_no"  let b=2  let c=4
          when 38  let a="amount"  let b=5  let c=3327
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: strcustr
    let tab[5].tabname = "strcustr"
    let tab[5].col_start = 39
    let tab[5].col_end = 72
    let tab[5].idx_start = 5
    let tab[5].idx_end = 6
    let tab[5].serial_start = 1000
    for n = 39 to 72
        case n
          when 39  let a="cust_code"  let b=0  let c=6
          when 40  let a="bus_name"  let b=0  let c=30
          when 41  let a="taxable"  let b=0  let c=1
          when 42  let a="contact"  let b=0  let c=20
          when 43  let a="phone"  let b=0  let c=20
          when 44  let a="address1"  let b=0  let c=30
          when 45  let a="address2"  let b=0  let c=30
          when 46  let a="city"  let b=0  let c=20
          when 47  let a="state"  let b=0  let c=2
          when 48  let a="zip"  let b=0  let c=10
          when 49  let a="country"  let b=0  let c=20
          when 50  let a="spec_shipping"  let b=0  let c=50
          when 51  let a="ar_type"  let b=0  let c=1
          when 52  let a="stmt_cycle"  let b=1  let c=2
          when 53  let a="fin_chg"  let b=0  let c=1
          when 54  let a="credit_limit"  let b=5  let c=3327
          when 55  let a="terms_code"  let b=0  let c=6
          when 56  let a="act_grp"  let b=0  let c=6
          when 57  let a="spec_billing"  let b=0  let c=50
          when 58  let a="ar_acct_dflt"  let b=2  let c=4
          when 59  let a="ar_department_dflt"  let b=0  let c=3
          when 60  let a="stmt_date"  let b=7  let c=4
          when 61  let a="stmt_amount"  let b=5  let c=3327
          when 62  let a="acct_bal"  let b=5  let c=3327
          when 63  let a="last_pay_date"  let b=7  let c=4
          when 64  let a="on_acct_amt"  let b=5  let c=3327
          when 65  let a="arch_bal"  let b=5  let c=3327
          when 66  let a="sls_psn_code"  let b=0  let c=6
          when 67  let a="trd_ds_code"  let b=0  let c=6
          when 68  let a="st_tx_code"  let b=0  let c=6
          when 69  let a="co_tx_code"  let b=0  let c=6
          when 70  let a="ci_tx_code"  let b=0  let c=6
          when 71  let a="bo_allowed"  let b=0  let c=1
          when 72  let a="comm_code"  let b=0  let c=6
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stropend
    let tab[6].tabname = "stropend"
    let tab[6].col_start = 73
    let tab[6].col_end = 88
    let tab[6].idx_start = 7
    let tab[6].idx_end = 8
    let tab[6].serial_start = 1000
    for n = 73 to 88
        case n
          when 73  let a="cust_code"  let b=0  let c=6
          when 74  let a="inv_no"  let b=0  let c=10
          when 75  let a="doc_no"  let b=2  let c=4
          when 76  let a="inv_desc"  let b=0  let c=30
          when 77  let a="inv_date"  let b=7  let c=4
          when 78  let a="orig_amount"  let b=5  let c=3327
          when 79  let a="disc_amt"  let b=5  let c=3327
          when 80  let a="balance"  let b=5  let c=3327
          when 81  let a="disc_bal"  let b=5  let c=3327
          when 82  let a="due_date"  let b=7  let c=4
          when 83  let a="disc_date"  let b=7  let c=4
          when 84  let a="ar_acct_no"  let b=2  let c=4
          when 85  let a="ar_department"  let b=0  let c=3
          when 86  let a="po_no"  let b=0  let c=10
          when 87  let a="po_date"  let b=7  let c=4
          when 88  let a="item_type"  let b=0  let c=2
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: strcashe
    let tab[7].tabname = "strcashe"
    let tab[7].col_start = 89
    let tab[7].col_end = 102
    let tab[7].idx_start = 9
    let tab[7].idx_end = 9
    let tab[7].serial_start = 1000
    for n = 89 to 102
        case n
          when 89  let a="rcpt_date"  let b=7  let c=4
          when 90  let a="doc_no"  let b=262  let c=4
          when 91  let a="cust_code"  let b=0  let c=6
          when 92  let a="check_no"  let b=0  let c=10
          when 93  let a="doc_desc"  let b=0  let c=30
          when 94  let a="cash_amt"  let b=5  let c=3327
          when 95  let a="cash_acct"  let b=2  let c=4
          when 96  let a="cash_department"  let b=0  let c=3
          when 97  let a="cash_deb_cred"  let b=0  let c=2
          when 98  let a="oa_amt"  let b=5  let c=3327
          when 99  let a="oa_acct"  let b=2  let c=4
          when 100  let a="oa_department"  let b=0  let c=3
          when 101  let a="oa_deb_cred"  let b=0  let c=2
          when 102  let a="ok_to_post"  let b=0  let c=1
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: strcashd
    let tab[8].tabname = "strcashd"
    let tab[8].col_start = 103
    let tab[8].col_end = 114
    let tab[8].idx_start = 10
    let tab[8].idx_end = 10
    let tab[8].serial_start = 1000
    for n = 103 to 114
        case n
          when 103  let a="doc_no"  let b=2  let c=4
          when 104  let a="inv_doc_no"  let b=2  let c=4
          when 105  let a="inv_no"  let b=0  let c=10
          when 106  let a="due_date"  let b=7  let c=4
          when 107  let a="dist_acct"  let b=2  let c=4
          when 108  let a="dist_department"  let b=0  let c=3
          when 109  let a="dist_amt"  let b=5  let c=3327
          when 110  let a="dist_deb_cred"  let b=0  let c=2
          when 111  let a="disc_acct"  let b=2  let c=4
          when 112  let a="disc_department"  let b=0  let c=3
          when 113  let a="disc_amt"  let b=5  let c=3327
          when 114  let a="disc_deb_cred"  let b=0  let c=2
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: strinvce
    let tab[9].tabname = "strinvce"
    let tab[9].col_start = 115
    let tab[9].col_end = 155
    let tab[9].serial_start = 1000
    for n = 115 to 155
        case n
          when 115  let a="doc_no"  let b=262  let c=4
          when 116  let a="inv_no"  let b=0  let c=10
          when 117  let a="department"  let b=0  let c=3
          when 118  let a="file_type"  let b=0  let c=1
          when 119  let a="ref_no"  let b=2  let c=4
          when 120  let a="tax"  let b=0  let c=1
          when 121  let a="inv_desc"  let b=0  let c=30
          when 122  let a="inv_date"  let b=7  let c=4
          when 123  let a="inv_note"  let b=0  let c=30
          when 124  let a="cust_code"  let b=0  let c=6
          when 125  let a="ship_to_code"  let b=0  let c=6
          when 126  let a="posted"  let b=0  let c=1
          when 127  let a="recurring"  let b=0  let c=1
          when 128  let a="terms_code"  let b=0  let c=6
          when 129  let a="due_date"  let b=7  let c=4
          when 130  let a="disc_date"  let b=7  let c=4
          when 131  let a="disc_pct"  let b=5  let c=1791
          when 132  let a="po_no"  let b=0  let c=10
          when 133  let a="po_date"  let b=7  let c=4
          when 134  let a="disc_acct_no"  let b=2  let c=4
          when 135  let a="disc_department"  let b=0  let c=3
          when 136  let a="disc_amount"  let b=5  let c=3327
          when 137  let a="disc_debit_credit"  let b=0  let c=2
          when 138  let a="tax_acct_no"  let b=2  let c=4
          when 139  let a="tax_department"  let b=0  let c=3
          when 140  let a="tax_amount"  let b=5  let c=3327
          when 141  let a="tax_debit_credit"  let b=0  let c=2
          when 142  let a="frght_acct_no"  let b=2  let c=4
          when 143  let a="frght_department"  let b=0  let c=3
          when 144  let a="frght_amount"  let b=5  let c=3327
          when 145  let a="frght_debit_credit"  let b=0  let c=2
          when 146  let a="misc_acct_no"  let b=2  let c=4
          when 147  let a="misc_department"  let b=0  let c=3
          when 148  let a="misc_amount"  let b=5  let c=3327
          when 149  let a="misc_debit_credit"  let b=0  let c=2
          when 150  let a="ar_acct_no"  let b=2  let c=4
          when 151  let a="ar_department"  let b=0  let c=3
          when 152  let a="ar_amount"  let b=5  let c=3327
          when 153  let a="ar_debit_credit"  let b=0  let c=2
          when 154  let a="ok_to_post"  let b=0  let c=1
          when 155  let a="recurr_ref"  let b=0  let c=10
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: strinvcd
    let tab[10].tabname = "strinvcd"
    let tab[10].col_start = 156
    let tab[10].col_end = 166
    let tab[10].idx_start = 11
    let tab[10].idx_end = 11
    let tab[10].serial_start = 1000
    for n = 156 to 166
        case n
          when 156  let a="doc_no"  let b=258  let c=4
          when 157  let a="line_no"  let b=1  let c=2
          when 158  let a="acct_no"  let b=2  let c=4
          when 159  let a="department"  let b=0  let c=3
          when 160  let a="amount"  let b=5  let c=3327
          when 161  let a="debit_credit"  let b=0  let c=2
          when 162  let a="item_no"  let b=0  let c=8
          when 163  let a="quantity"  let b=3  let c=8
          when 164  let a="pack"  let b=0  let c=6
          when 165  let a="description"  let b=0  let c=20
          when 166  let a="price"  let b=5  let c=3327
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: strshipr
    let tab[11].tabname = "strshipr"
    let tab[11].col_start = 167
    let tab[11].col_end = 186
    let tab[11].idx_start = 12
    let tab[11].idx_end = 12
    let tab[11].serial_start = 1000
    for n = 167 to 186
        case n
          when 167  let a="cust_code"  let b=0  let c=6
          when 168  let a="ship_to_code"  let b=0  let c=6
          when 169  let a="bus_name"  let b=0  let c=30
          when 170  let a="taxable"  let b=0  let c=1
          when 171  let a="contact"  let b=0  let c=20
          when 172  let a="phone"  let b=0  let c=20
          when 173  let a="address1"  let b=0  let c=30
          when 174  let a="address2"  let b=0  let c=30
          when 175  let a="city"  let b=0  let c=20
          when 176  let a="state"  let b=0  let c=2
          when 177  let a="zip"  let b=0  let c=10
          when 178  let a="country"  let b=0  let c=20
          when 179  let a="spec_shipping"  let b=0  let c=50
          when 180  let a="sls_psn_code"  let b=0  let c=6
          when 181  let a="trd_ds_code"  let b=0  let c=6
          when 182  let a="st_tx_code"  let b=0  let c=6
          when 183  let a="co_tx_code"  let b=0  let c=6
          when 184  let a="ci_tx_code"  let b=0  let c=6
          when 185  let a="bo_allowed"  let b=0  let c=1
          when 186  let a="comm_code"  let b=0  let c=6
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: strtermr
    let tab[12].tabname = "strtermr"
    let tab[12].col_start = 187
    let tab[12].col_end = 191
    let tab[12].idx_start = 13
    let tab[12].idx_end = 13
    let tab[12].serial_start = 1000
    for n = 187 to 191
        case n
          when 187  let a="terms_code"  let b=0  let c=6
          when 188  let a="terms_desc"  let b=0  let c=30
          when 189  let a="due_days"  let b=1  let c=2
          when 190  let a="disc_days"  let b=1  let c=2
          when 191  let a="disc_pct"  let b=5  let c=1791
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxtranr
    let tab[13].tabname = "stxtranr"
    let tab[13].col_start = 192
    let tab[13].col_end = 198
    let tab[13].idx_start = 14
    let tab[13].idx_end = 15
    let tab[13].serial_start = 1000
    for n = 192 to 198
        case n
          when 192  let a="orig_journal"  let b=256  let c=2
          when 193  let a="doc_no"  let b=258  let c=4
          when 194  let a="post_no"  let b=2  let c=4
          when 195  let a="post_date"  let b=7  let c=4
          when 196  let a="doc_date"  let b=263  let c=4
          when 197  let a="ref_code"  let b=0  let c=6
          when 198  let a="doc_desc"  let b=0  let c=30
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxprogr
    let tab[14].tabname = "stxprogr"
    let tab[14].col_start = 199
    let tab[14].col_end = 202
    let tab[14].idx_start = 16
    let tab[14].idx_end = 16
    let tab[14].serial_start = 1000
    for n = 199 to 202
        case n
          when 199  let a="module"  let b=0  let c=8
          when 200  let a="progname"  let b=0  let c=8
          when 201  let a="description"  let b=0  let c=30
          when 202  let a="use_trx"  let b=1  let c=2
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxerorh
    let tab[15].tabname = "stxerorh"
    let tab[15].col_start = 203
    let tab[15].col_end = 206
    let tab[15].idx_start = 17
    let tab[15].idx_end = 17
    let tab[15].serial_start = 1000
    for n = 203 to 206
        case n
          when 203  let a="err_module"  let b=0  let c=8
          when 204  let a="err_program"  let b=0  let c=8
          when 205  let a="err_number"  let b=1  let c=2
          when 206  let a="err_line"  let b=0  let c=40
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxerord
    let tab[16].tabname = "stxerord"
    let tab[16].col_start = 207
    let tab[16].col_end = 212
    let tab[16].idx_start = 18
    let tab[16].idx_end = 18
    let tab[16].serial_start = 1000
    for n = 207 to 212
        case n
          when 207  let a="err_module"  let b=0  let c=8
          when 208  let a="err_program"  let b=0  let c=8
          when 209  let a="err_number"  let b=1  let c=2
          when 210  let a="a_b"  let b=0  let c=1
          when 211  let a="line_no"  let b=1  let c=2
          when 212  let a="err_text"  let b=0  let c=60
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxhelph
    let tab[17].tabname = "stxhelph"
    let tab[17].col_start = 213
    let tab[17].col_end = 215
    let tab[17].idx_start = 19
    let tab[17].idx_end = 19
    let tab[17].serial_start = 1000
    for n = 213 to 215
        case n
          when 213  let a="hlp_module"  let b=0  let c=8
          when 214  let a="hlp_program"  let b=0  let c=8
          when 215  let a="hlp_number"  let b=1  let c=2
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxhelpd
    let tab[18].tabname = "stxhelpd"
    let tab[18].col_start = 216
    let tab[18].col_end = 220
    let tab[18].idx_start = 20
    let tab[18].idx_end = 20
    let tab[18].serial_start = 1000
    for n = 216 to 220
        case n
          when 216  let a="hlp_module"  let b=0  let c=8
          when 217  let a="hlp_program"  let b=0  let c=8
          when 218  let a="hlp_number"  let b=1  let c=2
          when 219  let a="line_no"  let b=1  let c=2
          when 220  let a="hlp_text"  let b=0  let c=60
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stgtranr
    let tab[19].tabname = "stgtranr"
    let tab[19].col_start = 221
    let tab[19].col_end = 225
    let tab[19].idx_start = 21
    let tab[19].idx_end = 22
    let tab[19].serial_start = 1000
    for n = 221 to 225
        case n
          when 221  let a="orig_journal"  let b=256  let c=2
          when 222  let a="doc_no"  let b=258  let c=4
          when 223  let a="acct_period"  let b=0  let c=2
          when 224  let a="acct_year"  let b=0  let c=4
          when 225  let a="status"  let b=0  let c=1
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stgactvd
    let tab[20].tabname = "stgactvd"
    let tab[20].col_start = 226
    let tab[20].col_end = 231
    let tab[20].idx_start = 23
    let tab[20].idx_end = 24
    let tab[20].serial_start = 1000
    for n = 226 to 231
        case n
          when 226  let a="orig_journal"  let b=256  let c=2
          when 227  let a="doc_no"  let b=258  let c=4
          when 228  let a="acct_no"  let b=2  let c=4
          when 229  let a="department"  let b=0  let c=3
          when 230  let a="amount"  let b=5  let c=3327
          when 231  let a="debit_credit"  let b=0  let c=1
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: strtranv
    let tab[21].tabname = "strtranv"
    let tab[21].viw_start = 1
    let tab[21].viw_end = 8

    # Table: stractvv
    let tab[22].tabname = "stractvv"
    let tab[22].viw_start = 9
    let tab[22].viw_end = 19

    # Indexes:
    for n = 1 to 24
        case n
          when 1
            let a="i1dtablr"  let d="N"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 2
            let a="i1rtranr"  let d="Y"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 3
            let a="i1ractvd"  let d="N"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 4
            let a="i2ractvd"  let d="N"  let e="N"
            let f=4  let g=0  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 5
            let a="i1rcustr"  let d="Y"  let e="N"
            let f=1  let g=0  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 6
            let a="i2rcustr"  let d="N"  let e="N"
            let f=2  let g=0  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 7
            let a="i1ropend"  let d="N"  let e="N"
            let f=1  let g=0  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 8
            let a="i2ropend"  let d="Y"  let e="N"
            let f=3  let g=0  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 9
            let a="i1rcashe"  let d="N"  let e="N"
            let f=2  let g=0  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 10
            let a="i1rcashd"  let d="N"  let e="N"
            let f=1  let g=4  let h=2  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 11
            let a="i1rinvcd"  let d="N"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 12
            let a="i1rshipr"  let d="Y"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 13
            let a="i1rtermr"  let d="Y"  let e="N"
            let f=1  let g=0  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 14
            let a="i1xtranr"  let d="Y"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 15
            let a="i2xtranr"  let d="N"  let e="N"
            let f=6  let g=0  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 16
            let a="i1xprogr"  let d="N"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 17
            let a="i1xerorh"  let d="Y"  let e="N"
            let f=1  let g=2  let h=3  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 18
            let a="i1xerord"  let d="N"  let e="N"
            let f=1  let g=2  let h=3  let i=4
            let j=5  let k=0  let l=0  let m=0
          when 19
            let a="i1xhelph"  let d="Y"  let e="N"
            let f=1  let g=2  let h=3  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 20
            let a="i1xhelpd"  let d="N"  let e="N"
            let f=1  let g=2  let h=3  let i=4
            let j=0  let k=0  let l=0  let m=0
          when 21
            let a="i1gtranr"  let d="Y"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 22
            let a="i2gtranr"  let d="N"  let e="N"
            let f=5  let g=4  let h=3  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 23
            let a="i1gactvd"  let d="N"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 24
            let a="i2gactvd"  let d="N"  let e="N"
            let f=3  let g=4  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
        end case
        let idx[n].idxname = a
        let idx[n].unique_idx = d
        let idx[n].clustered = e
        let idx[n].part[1] = f
        let idx[n].part[2] = g
        let idx[n].part[3] = h
        let idx[n].part[4] = i
        let idx[n].part[5] = j
        let idx[n].part[6] = k
        let idx[n].part[7] = l
        let idx[n].part[8] = m
    end for

    # Views:
    for n = 1 to 19
        case n
          when 1 let t="create view strtranv as  select  stxtranr.ori"
          when 2 let t="g_journal, stxtranr.doc_no,  stxtranr.post_no"
          when 3 let t=",  stxtranr.post_date, stxtranr.doc_date,  st"
          when 4 let t="xtranr.ref_code,  stxtranr.doc_desc,  strtran"
          when 5 let t="r.inv_chk_no,  strtranr.doc_type  from  strtr"
          when 6 let t="anr, stxtranr  where  stxtranr.orig_journal="
          when 7 let t=" strtranr.orig_journal and  stxtranr.doc_no ="
          when 8 let t=" strtranr.doc_no ;"
          when 9 let t="create view stractvv as  select  stxtranr.ori"
          when 10 let t="g_journal, stxtranr.doc_no,  stxtranr.post_no"
          when 11 let t=",  stxtranr.post_date, stxtranr.doc_date,  st"
          when 12 let t="xtranr.ref_code,  stxtranr.doc_desc,  strtran"
          when 13 let t="r.inv_chk_no,  strtranr.doc_type,  stractvd.a"
          when 14 let t="ct_type,  stractvd.inv_doc_no,  stractvd.amou"
          when 15 let t="nt  from strtranr, stxtranr, stractvd  where"
          when 16 let t="  strtranr.doc_no =stxtranr.doc_no and  strtr"
          when 17 let t="anr.doc_no = stractvd.doc_no and  strtranr.or"
          when 18 let t="ig_journal = stxtranr.orig_journal and  strtr"
          when 19 let t="anr.orig_journal= stractvd.orig_journal  ;"
        end case
        let viw[n].v_text = t
    end for

end function
# define_data()

