########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../lib.4gm/ar.4gs/ar_actvz.4gl  1.10  Delta: 9/4/90
########################################################################

database standard

############################################################
function ar_actvz(cust_code)
# returns nothing
############################################################
# This function is passed a customer code and, from that,
# displays a zoom window to A/R activity view.  It also
# provides the option of a subzoom that shows a specific 
# invoice in detail.
# The function is just for viewing activity and returns
# nothing.
#
    define
        jour array[100] of char(2),
        scratch char(15),
        actv_list array[100] of record
            doc_type    like strtranr.doc_type,
            doc_no      like stxtranr.doc_no,
            doc_date    like stxtranr.doc_date,
            inv_no      like stropend.inv_no,
            amount      like stractvd.amount,
            due_date    like stropend.due_date,
            balance     like stropend.balance
        end record,
        counter             smallint,
        cust_code       like stxtranr.ref_code,
        bus_name        like strcustr.bus_name

    initialize actv_list[1].* to null
    let jour[1] = null
    for counter = 2 to 100
        let actv_list[counter].* = actv_list[1].*
        let jour[counter] = null
    end for

    declare actv_lines cursor for
    select strtranr.orig_journal, strtranr.doc_type, stxtranr.doc_no,
           stxtranr.doc_date, stropend.inv_no,
           stractvd.amount
      from stxtranr, strtranr, stractvd,
           outer stropend
     where stxtranr.ref_code = cust_code and
           stxtranr.doc_no = stractvd.doc_no and
           stxtranr.orig_journal = stractvd.orig_journal and
           stxtranr.doc_no = strtranr.doc_no and
           stxtranr.orig_journal = strtranr.orig_journal and
           stractvd.act_type != "D" and
           stractvd.inv_doc_no = stropend.doc_no
     order by stxtranr.doc_date desc, stropend.inv_no

    open window aractvwin at 2, 3
        with form "../../lib.4gm/ar.4gs/ar_actvz"
            attribute (border, blue)
    call ar_custn(cust_code) returning bus_name
    display " ",cust_code clipped, " -  ", bus_name at 1,1

    call menu_line()

    let counter = 1

    whenever error continue
    foreach actv_lines into jour[counter],
            actv_list[counter].doc_type thru actv_list[counter].amount
        if actv_list[counter].doc_type = "IN"
        then
            select
                stropend.balance,
                stropend.due_date
              into
                actv_list[counter].balance,
                actv_list[counter].due_date
              from stropend
              where
                stropend.doc_no = actv_list[counter].doc_no
        end if
        let counter = counter + 1
        if counter > 100
        then
            call fg_error("lib_ar","ar_actvz",1) # too many a/r activity rows
            exit foreach
        end if
    end foreach
    whenever error call error_handler
    if sqlca.sqlcode != 0
    then
        call fg_error("lib_ar","ar_actvz",2) # cannot read a/r activity table
        let sqlca.sqlcode = 0
    end if

    display " [ESC] to exit  [CTRL]-[z] invoice detail" at 2,1

    call set_count(counter - 1)

    display array actv_list to s_zoom.*
        on key(control-f)
            let counter = arr_curr()
            let scratch = "stxtranr",jour[counter]
            call al_addlz(scratch, actv_list[counter].doc_no,"","")
        on key(control-z)
            let counter = arr_curr()
            if actv_list[counter].doc_type = "IN"
            then
                call ar_invcz(actv_list[counter].doc_no)
            end if
    end display

    if int_flag != 0
    then
        let int_flag = 0
    end if

    close window aractvwin

end function
# ar_actvz()
