########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../lib.4gm/ar.4gs/ar_custz.4gl  1.6  Delta: 9/4/90
########################################################################

database standard

############################################################
function ar_custz()
# returns cust_code
############################################################
# This function prompts the user for criteria for selecting
# a customer (function cust_sel).  If the criteria exist in the
# strcustr (open items table), those customers selected are
# displayed in a window where the user has the option of viewing
# data of any of the selected customers or selecting one
# (function cust_get) whose customer code is returned.
#
    define
        sel_cust char(100),
        query_var char(200),
        cust_items array[101] of record
            cust_code like strcustr.cust_code,
            bus_name like strcustr.bus_name,
            contact like strcustr.contact,
            phone like strcustr.phone
        end record,
        counter             smallint,
        pcurr               smallint,
        scurr               smallint

    let pcurr = arr_curr()
    let scurr = scr_line()

    call cust_sel() returning sel_cust

    if sel_cust is null
    then
        let cust_items[1].cust_code = ""
        return cust_items[1].cust_code
    end if


    open window custwin at 2, 3
        with form "../../lib.4gm/ar.4gs/ar_custz"
            attribute (border, blue)

    let query_var = "select strcustr.cust_code, strcustr.bus_name, ",
                    "strcustr.contact, strcustr.phone ",
                    "from strcustr where ", sel_cust clipped,
                    " order by strcustr.cust_code "

    prepare query_mode from query_var

    declare cust_list cursor for query_mode

    call menu_line()

    display " Select desired customer and press [ESC] to choose  [CTRL]-[z] to view data." at 1,1
    display " [DOWN ARROW] or [UP ARROW] to Scroll,  [F3] or [F4] to Page" at 2,1

    let counter = 1
    open cust_list
    foreach cust_list into cust_items[counter].*
        let counter = counter + 1
        if counter > 100
        then
            exit foreach
        end if
    end foreach

    call set_count(counter -1)

    display array cust_items to s_zoom.*
        on key(control-f)
            let counter = arr_curr()
            call al_addlz("strcustr",cust_items[counter].cust_code,"","")
        on key(control-z)
            let counter = arr_curr()
            call cust_get(cust_items[counter].cust_code)
    end display

    let counter = arr_curr()
    if int_flag != 0
    then
        let cust_items[counter].cust_code = ""
        let int_flag = 0
    end if

    close window custwin

    return cust_items[counter].cust_code

end function
# ar_custz()

############################################################
function cust_get(cust_code)
############################################################
# This function is passed a customer code from function ar_custz
# and, from that, displays information of selected customers.
# It returns nothing.
#
    define
        p_rcustr record like strcustr.*,
        ship_to_code like strshipr.ship_to_code,
        cust_code like strcustr.cust_code

    select * into p_rcustr.* from strcustr
                where strcustr.cust_code = cust_code

    if sqlca.sqlcode != 0
    then
        let sqlca.sqlcode = 0
        return
    end if

    open window custzwin at 2,3
        with form "../../lib.4gm/ar.4gs/custdetl"
            attribute (border, blue)

    call menu_line()

    display by name p_rcustr.cust_code thru p_rcustr.on_acct_amt

    menu " View Customer"

        command key ("!")
            call ring_bang()

        command key ("A") "Activity" " View Customer Activity"
            call ar_actvz(p_rcustr.cust_code)

        command key ("S") "Ship-To" " View Customer Ship-To Addresses"
            call ar_shipz(p_rcustr.cust_code) returning ship_to_code

        command key (e,x,q,interrupt) "Quit" " Return to Entry screen"
                if int_flag != 0
                then
                    let int_flag = 0
                end if
             exit menu
    end menu

    close window custzwin
    return

end function

############################################################
function cust_sel()
# returns sel_cust
############################################################
# This function prompts the user to enter customer selection 
# criteria (customer business name and customer code) from which
# it creates a construct and returns it to function ar_custz.
#
    define
        sel_cust char(100)

    call sel_wind()
    display "ENTER SELECTION CRITERIA" at 2,1 attribute(white)
    display "Press [DEL] to Cancel or [ESC] to Select" at 2,30 attribute(white)
    open form sel_screen from "../../lib.4gm/ar.4gs/sel_cust"
    display form sel_screen

    construct sel_cust
        on
           strcustr.cust_code,
           strcustr.bus_name
        from
           s_data.cust_code,
           s_data.bus_name

    if int_flag = 1
    then
       let int_flag = 0
       let sel_cust = null
    end if

    close form sel_screen
    close window selwin

    return sel_cust

end function
#custsel
