########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../lib.4gm/ar.4gs/ar_iactz.4gl  1.7  Delta: 9/4/90
########################################################################

database standard

############################################################
function ar_iactz(cust_code, inv_doc_no)
# return nothing
############################################################
# This function is passed a customer code and an invoice number
# and, from these, displays a zoom window to show all of the
# activity on a specific a invoice.
# It is just for viewing activity and returns nothing. 
#
    define
        jour array[100] of char(2),
        scratch char(15),
        actv_list array[100] of record
            doc_type    like strtranr.doc_type,
            doc_no      like stxtranr.doc_no,
            doc_date    like stxtranr.doc_date,
            inv_no      like stropend.inv_no,
            amount      like stractvd.amount,
            due_date    like stropend.due_date,
            balance     like stropend.balance
        end record,
        counter             smallint,
        inv_doc_no      like stractvd.inv_doc_no,
        invoice_no      like stropend.inv_no,
        cust_code       like strcustr.cust_code,
        bus_name        like strcustr.bus_name

    initialize actv_list[1].* to null
    let jour[1] = null
    for counter = 2 to 100
        let actv_list[counter].* = actv_list[1].*
        let jour[counter] = null
    end for

    declare actv_lines cursor for
    select  strtranr.orig_journal, strtranr.doc_type, stxtranr.doc_no,
            stxtranr.doc_date, stropend.inv_no, stractvd.amount
      from  stxtranr, strtranr, stractvd, outer stropend
      where
            stxtranr.ref_code = cust_code and
            stxtranr.doc_no = stractvd.doc_no and
            stxtranr.orig_journal = stractvd.orig_journal and
            stractvd.inv_doc_no = inv_doc_no and
            stractvd.act_type != "D" and
            stractvd.inv_doc_no = stropend.doc_no and
            stxtranr.doc_no = strtranr.doc_no and
            stxtranr.orig_journal = strtranr.orig_journal
     order  by stxtranr.doc_date

    open window ariactwin at 2, 3
        with form "../../lib.4gm/ar.4gs/ar_actvz"
            attribute (border, blue)

    call menu_line()

    let counter = 1
    open actv_lines
    foreach actv_lines into jour[counter], 
            actv_list[counter].doc_type thru actv_list[counter].amount
        if actv_list[counter].doc_type = "IN"
        then
            select 
              stropend.balance,
              stropend.due_date
            into
              actv_list[counter].balance,
              actv_list[counter].due_date
            from stropend
            where
              stropend.doc_no = actv_list[counter].doc_no
        end if
        let counter = counter + 1
        if counter > 100
        then
            call fg_error("lib_ar","ar_iactz",1) # too many a/r activity rows
            exit foreach
        end if
    end foreach
    if sqlca.sqlcode != 0
    then
        call fg_error("lib_ar","ar_iactz",2) # cannot read a/r activity table
        let sqlca.sqlcode = 0
    end if

    call ar_custn(cust_code) returning bus_name
    display " ",cust_code clipped, " -  ", bus_name,
        "all activity for invoice: ", invoice_no at 1,1
    display " [ESC] to exit" at 2,1

    call set_count(counter - 1)

    display array actv_list to s_zoom.*
        on key(control-f)
            let counter = arr_curr()
            let scratch = "stxtranr",jour[counter]
            call al_addlz(scratch, actv_list[counter].doc_no,"","")
    end display

    if int_flag != 0
    then
        let int_flag = 0
    end if

    close window ariactwin

end function
# ar_iactz()
