#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../lib.4gm/ar.4gs/ar_openz.4gl  1.6  Delta: 12/11/89
#####################################################################

database standard

############################################################
function ar_openz(cust_code)
# returns doc_no
############################################################
# This function is passed a customer code and, from that, displays
# a zoom window into the A/R open item file.  The user is 
# permitted to scroll through the items and select a document
# number which is returned in doc_no.
#
    define
        orig_journal like stractvd.orig_journal,
        scratch char(15),
        open_items array[100] of record
            doc_no      like stropend.doc_no,
            inv_no      like stropend.inv_no,
            inv_date    like stropend.inv_date,
            due_date    like stropend.due_date,
            orig_amount like stropend.orig_amount,
            balance     like stropend.balance
        end record,
        counter             smallint,
        cust_code       like stropend.cust_code,
        bus_name        like strcustr.bus_name,
        doc_no          like stropend.doc_no

# initialize the array
    initialize open_items[1].* to null
    for counter = 2 to 100
    let open_items[counter].* = open_items[1].*
    end for

    open window aropenwin at 2, 3
        with form "../../lib.4gm/ar.4gs/ar_openz"
            attribute (border, blue)

    declare item_list cursor for
        select stropend.doc_no, stropend.inv_no, stropend.inv_date,
            stropend.due_date, stropend.orig_amount, stropend.balance
            from stropend
                where stropend.cust_code = cust_code
                order by stropend.inv_date desc

    call menu_line()
    call ar_custn(cust_code) returning bus_name

    display " Select the desired item and press [ESC] to choose" at 1,1
    display " [DOWN ARROW] or [UP ARROW] to Scroll,  [F3] or [F4] to Page" at 2,1
    display " Customer: ",bus_name at 4,1

    let counter = 1
    open item_list
    foreach item_list into open_items[counter].*
        let counter = counter + 1
        if counter > 100
        then
            exit foreach
        end if
    end foreach

    call set_count(counter -1)

    display array open_items to s_zoom.*
        on key(control-z)
            let counter = arr_curr()
            call ar_invcz(open_items[counter].doc_no)
        on key(control-f)
            let counter = arr_curr()
            # We have no other way of getting original journal except
            # by virtue of the fact that in the actvd table, there is
            # only one row that both the doc_no, and the inv_doc_no are
            # the same.  That row is from the originating transaction, and
            # the orig_journal of that row is the correct one.

            select orig_journal into orig_journal from stractvd
              where stractvd.inv_doc_no = open_items[counter].doc_no
                and stractvd.doc_no = open_items[counter].doc_no
            let scratch = "stxtranr",orig_journal
            call al_addlz(scratch,open_items[counter].doc_no,"","")
    end display

    let counter = arr_curr()
    if int_flag != 0
    then
        let open_items[counter].doc_no = ""
        let int_flag = 0
    end if
    let doc_no = open_items[counter].doc_no

    close window aropenwin

    return doc_no

end function
# ar_openz()

