##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../lib.4gm/ar.4gs/ar_shipz.4gl  1.4  Last Delta: 12/11/89
##############################################################################

database standard

############################################################
function ar_shipz(cust_code)
# return ship_to_code
############################################################
# This function is passed a customer code and, from that,
# displays a zoom window to that customer's ship-to detail view.
# The user may scroll through the screen and select the
# ship-to from which the ship-to-code is returned.
#
    define
        ship_items array[100] of record
            ship_to_code like strshipr.ship_to_code,
            bus_name like strshipr.bus_name,
            taxable like strshipr.taxable,
            contact like strshipr.contact,
            phone like strshipr.phone,
            address1 like strshipr.address1,
            address2 like strshipr.address2,
            city like strshipr.city,
            state like strshipr.state,
            zip like strshipr.zip,
            country like strshipr.country,
            spec_shipping like strshipr.spec_shipping
        end record,
        ship_add record
            ship_to_code like strshipr.ship_to_code,
            bus_name like strshipr.bus_name,
            taxable like strshipr.taxable,
            contact like strshipr.contact,
            phone like strshipr.phone,
            address1 like strshipr.address1,
            address2 like strshipr.address2,
            city like strshipr.city,
            state like strshipr.state,
            zip like strshipr.zip,
            country like strshipr.country,
            spec_shipping like strshipr.spec_shipping

        end record,
        cust_code like strcustr.cust_code,
        cust_name like strcustr.bus_name,
        counter             smallint,
        pcurr               smallint,
        scurr               smallint

    let pcurr = arr_curr()
    let scurr = scr_line()

    open window shipwind at 2, 3
        with form "../../lib.4gm/ar.4gs/ar_shipz"
            attribute (border, blue)

    declare ship_list cursor for
        select ship_to_code, bus_name, taxable, contact,
               phone, address1, address2, city,
               state, zip, country, spec_shipping
            from strshipr
                where strshipr.cust_code = cust_code
                    order by strshipr.ship_to_code

    open ship_list
    let counter = 1
    foreach ship_list into ship_items[counter].*
        display ship_items[counter].* to s_rshipr[counter].*
        let counter = counter + 1
        if counter > 2
        then
            exit foreach
        end if
    end foreach

    menu " Action"

    command "Select" " Select Ship-To Address"
        call menu_line()
        call ar_custn(cust_code) returning cust_name
    display " Select the desired Ship-To Code and press [ESC] to choose" at 1,1
    display " [DOWN ARROW] or [UP ARROW] to Scroll,  [F3] or [F4] to Page" at 2,1

        let counter = 1
        open ship_list
        foreach ship_list into ship_items[counter].*
            let counter = counter + 1
            if counter > 100
            then
                exit foreach
            end if
        end foreach

        call set_count(counter -1)

        display array ship_items to s_rshipr.*
            on key(control-f)
                let counter = arr_curr()
                call al_addlz("strshipr",cust_code,ship_items[counter].ship_to_code, "")
        end display

        let counter = arr_curr()
        if int_flag != 0
        then
            let ship_items[counter].ship_to_code = ""
            let int_flag = 0
        end if
    exit menu

    command "Add" " Add Ship-To Code"
        open window shipaddwin at 2, 3
            with form "../../lib.4gm/ar.4gs/shipadd"
                attribute (border, white)
            call ar_custn(cust_code) returning cust_name
            display " ",cust_code clipped, " -  ", cust_name at 1,1
            input by name ship_add.*
                on key(control-f)
                    call al_addlz("strshipr",cust_code,ship_add.ship_to_code, "")
                after field ship_to_code
                    if ar_shipd(cust_code,ship_add.ship_to_code)
                    then
                        call fg_error("lib_ar","shipadd",1) # Duplicate Ship-To code - Cannot add.
                        next field ship_to_code
                    end if
                    if ship_add.ship_to_code is null
                    then
                        call fg_error("lib_ar","shipadd",2) # Ship-To code must be entered
                        next field ship_to_code
                    end if
                after field bus_name
                    if ship_add.bus_name is null
                    then
                        call fg_error("lib_ar","shipadd",3) # Business name must be entered
                        next field bus_name
                    end if
            end input
            if int_flag = 0
            then
                insert into strshipr (cust_code, ship_to_code, bus_name,
                    taxable, contact, phone, address1, address2, city,
                    state, zip, country, spec_shipping)
                    values (cust_code, ship_add.*)
            else
                let int_flag = 0
            end if
            close window shipaddwin
            let counter = 1
            open ship_list
            foreach ship_list into ship_items[counter].*
                display ship_items[counter].* to s_rshipr[counter].*
                let counter = counter + 1
                if counter > 2
                then
                    exit foreach
                end if
            end foreach

    command key ("!")
        call ring_bang()

    command key(e,x,q,interrupt) "Quit" " Return to previous window"
        if int_flag != 0
        then
            let int_flag = 0
        end if
        exit menu

    end menu

    close window shipwind

    return ship_items[counter].ship_to_code

end function
# ar_shipz()
